/*********************************************************************/
/*                                                                   */
/*             Optimized BLAS libraries                              */
/*                     By Kazushige Goto <kgoto@tacc.utexas.edu>     */
/*                                                                   */
/* Copyright (c) The University of Texas, 2005. All rights reserved. */
/* UNIVERSITY EXPRESSLY DISCLAIMS ANY AND ALL WARRANTIES CONCERNING  */
/* THIS SOFTWARE AND DOCUMENTATION, INCLUDING ANY WARRANTIES OF      */
/* MERCHANTABILITY, FITNESS FOR ANY PARTICULAR PURPOSE,              */
/* NON-INFRINGEMENT AND WARRANTIES OF PERFORMANCE, AND ANY WARRANTY  */
/* THAT MIGHT OTHERWISE ARISE FROM COURSE OF DEALING OR USAGE OF     */
/* TRADE. NO WARRANTY IS EITHER EXPRESS OR IMPLIED WITH RESPECT TO   */
/* THE USE OF THE SOFTWARE OR DOCUMENTATION.                         */
/* Under no circumstances shall University be liable for incidental, */
/* special, indirect, direct or consequential damages or loss of     */
/* profits, interruption of business, or related expenses which may  */
/* arise from use of Software or Documentation, including but not    */
/* limited to those resulting from defects in Software and/or        */
/* Documentation, or loss or inaccuracy of data of any kind.         */
/*********************************************************************/

#define ASSEMBLER
#include "common.h"
 
#define OLD_M	ARG1
#define OLD_N	ARG2
#define M	%r13
#define N	%r14
#define K	ARG3
#define A	ARG4
#define B	ARG5
#define C	ARG6
#define LDC	%r10
	
#define I	%r11
#define AO	ARG1
#define BO	ARG2
#define	CO1	%r15
#define CO2	%rbp
#define BB	%r12
	
#define PREFETCH     prefetch
#define PREFETCHSIZE (8 * 5 + 4)

#define RPREFETCHSIZE (8 *  7 + 4)
#define WPREFETCHSIZE (8 *  8 + 4)

#define LOCAL_BUFFER_SIZE  GEMM_Q * GEMM_UNROLL_N * COMPSIZE * 16

#define STACKSIZE 64
	
#define POSINV	  0(%rsp)
#define ALPHA_R	 16(%rsp)
#define ALPHA_I	 32(%rsp)
#define J	 48(%rsp)
#define OFFSET	 56(%rsp)
#define KK	 64(%rsp)
#define KKK	 72(%rsp)
#define BUFFER	128(%rsp)

#define KERNEL(xx) \
	mulpd	%xmm0, %xmm1 ;\
	addpd	%xmm1, %xmm8 ;\
	movapd	-16 * SIZE + 2 * (xx) * SIZE(BO, %rax, 8), %xmm1 ;\
	mulpd	%xmm0, %xmm3 ;\
	addpd	%xmm3, %xmm9 ;\
	movapd	-14 * SIZE + 2 * (xx) * SIZE(BO, %rax, 8), %xmm3 ;\
	mulpd	%xmm0, %xmm5 ;\
	PREFETCH	(PREFETCHSIZE     +  0) * SIZE + 1 * (xx) * SIZE(AO, %rax, 4) ;\
	mulpd	-10 * SIZE + 2 * (xx) * SIZE(BO, %rax, 8), %xmm0 ;\
	addpd	%xmm5, %xmm10 ;\
	movapd	-12 * SIZE + 2 * (xx) * SIZE(BO, %rax, 8), %xmm5 ;\
	addpd	%xmm0, %xmm11 ;\
	movapd	-8 * SIZE + 1 * (xx) * SIZE(AO, %rax, 4), %xmm0 ;\
	mulpd	%xmm2, %xmm1 ;\
	addpd	%xmm1, %xmm12 ;\
	movapd	 0 * SIZE + 2 * (xx) * SIZE(BO, %rax, 8), %xmm1 ;\
	mulpd	%xmm2, %xmm3 ;\
	addpd	%xmm3, %xmm13 ;\
	movapd	-6 * SIZE + 2 * (xx) * SIZE(BO, %rax, 8), %xmm3 ;\
	mulpd	%xmm2, %xmm5 ;\
	mulpd	-10 * SIZE + 2 * (xx) * SIZE(BO, %rax, 8), %xmm2 ;\
	addpd	%xmm5, %xmm14 ;\
	movapd	 -4 * SIZE + 2 * (xx) * SIZE(BO, %rax, 8), %xmm5 ;\
	addpd	%xmm2, %xmm15 ;\
	movapd	-6 * SIZE + 1 * (xx) * SIZE(AO, %rax, 4), %xmm2 ;\
	mulpd	%xmm4, %xmm7 ;\
	addpd	%xmm7, %xmm8 ;\
	movapd	-8 * SIZE + 2 * (xx) * SIZE(BO, %rax, 8), %xmm7 ;\
	mulpd	%xmm4, %xmm3 ;\
	addpd	%xmm3, %xmm9 ;\
	movapd	-6 * SIZE + 2 * (xx) * SIZE(BO, %rax, 8), %xmm3 ;\
	mulpd	%xmm4, %xmm5 ;\
	mulpd	-2 * SIZE + 2 * (xx) * SIZE(BO, %rax, 8), %xmm4 ;\
	addpd	%xmm5, %xmm10 ;\
	movapd	-4 * SIZE + 2 * (xx) * SIZE(BO, %rax, 8), %xmm5 ;\
	addpd	%xmm4, %xmm11 ;\
	movapd	-4 * SIZE + 1 * (xx) * SIZE(AO, %rax, 4), %xmm4 ;\
	mulpd	%xmm6, %xmm7 ;\
	addpd	%xmm7, %xmm12 ;\
	movapd	 8 * SIZE + 2 * (xx) * SIZE(BO, %rax, 8), %xmm7 ;\
	mulpd	%xmm6, %xmm3 ;\
	addpd	%xmm3, %xmm13 ;\
	movapd	 2 * SIZE + 2 * (xx) * SIZE(BO, %rax, 8), %xmm3 ;\
	mulpd	%xmm6, %xmm5 ;\
	mulpd	-2 * SIZE + 2 * (xx) * SIZE(BO, %rax, 8), %xmm6 ;\
	addpd	%xmm5, %xmm14 ;\
	movapd	 4 * SIZE + 2 * (xx) * SIZE(BO, %rax, 8), %xmm5 ;\
 	PREFETCH	(PREFETCHSIZE     +  8) * SIZE + 1 * (xx) * SIZE(AO, %rax, 4) ;\
	addpd	%xmm6, %xmm15 ;\
	movapd	-2 * SIZE + 1 * (xx) * SIZE(AO, %rax, 4), %xmm6 ;\
	mulpd	%xmm0, %xmm1 ;\
	addpd	%xmm1, %xmm8 ;\
	movapd	 0 * SIZE + 2 * (xx) * SIZE(BO, %rax, 8), %xmm1 ;\
	mulpd	%xmm0, %xmm3 ;\
	addpd	%xmm3, %xmm9 ;\
	movapd	 2 * SIZE + 2 * (xx) * SIZE(BO, %rax, 8), %xmm3 ;\
	mulpd	%xmm0, %xmm5 ;\
	mulpd	 6 * SIZE + 2 * (xx) * SIZE(BO, %rax, 8), %xmm0 ;\
	addpd	%xmm5, %xmm10 ;\
	movapd	 4 * SIZE + 2 * (xx) * SIZE(BO, %rax, 8), %xmm5 ;\
	addpd	%xmm0, %xmm11 ;\
	movapd	 0 * SIZE + 1 * (xx) * SIZE(AO, %rax, 4), %xmm0 ;\
	mulpd	%xmm2, %xmm1 ;\
	addpd	%xmm1, %xmm12 ;\
	movapd	16 * SIZE + 2 * (xx) * SIZE(BO, %rax, 8), %xmm1 ;\
	mulpd	%xmm2, %xmm3 ;\
	addpd	%xmm3, %xmm13 ;\
	movapd	10 * SIZE + 2 * (xx) * SIZE(BO, %rax, 8), %xmm3 ;\
	mulpd	%xmm2, %xmm5 ;\
	mulpd	 6 * SIZE + 2 * (xx) * SIZE(BO, %rax, 8), %xmm2 ;\
	addpd	%xmm5, %xmm14 ;\
	movapd	12 * SIZE + 2 * (xx) * SIZE(BO, %rax, 8), %xmm5 ;\
	addpd	%xmm2, %xmm15 ;\
	movapd	 2 * SIZE + 1 * (xx) * SIZE(AO, %rax, 4), %xmm2 ;\
	mulpd	%xmm4, %xmm7 ;\
	addpd	%xmm7, %xmm8 ;\
	movapd	 8 * SIZE + 2 * (xx) * SIZE(BO, %rax, 8), %xmm7 ;\
	mulpd	%xmm4, %xmm3 ;\
	addpd	%xmm3, %xmm9 ;\
	movapd	10 * SIZE + 2 * (xx) * SIZE(BO, %rax, 8), %xmm3 ;\
	mulpd	%xmm4, %xmm5 ;\
	mulpd	14 * SIZE + 2 * (xx) * SIZE(BO, %rax, 8), %xmm4 ;\
	addpd	%xmm5, %xmm10 ;\
	movapd	12 * SIZE + 2 * (xx) * SIZE(BO, %rax, 8), %xmm5 ;\
	addpd	%xmm4, %xmm11 ;\
	movapd	 4 * SIZE + 1 * (xx) * SIZE(AO, %rax, 4), %xmm4 ;\
	mulpd	%xmm6, %xmm7 ;\
	addpd	%xmm7, %xmm12 ;\
	movapd	24 * SIZE + 2 * (xx) * SIZE(BO, %rax, 8), %xmm7 ;\
	mulpd	%xmm6, %xmm3 ;\
	addpd	%xmm3, %xmm13 ;\
	movapd	18 * SIZE + 2 * (xx) * SIZE(BO, %rax, 8), %xmm3 ;\
	mulpd	%xmm6, %xmm5 ;\
	mulpd	14 * SIZE + 2 * (xx) * SIZE(BO, %rax, 8), %xmm6 ;\
	addpd	%xmm5, %xmm14 ;\
	movapd	20 * SIZE + 2 * (xx) * SIZE(BO, %rax, 8), %xmm5 ;\
	addpd	%xmm6, %xmm15 ;\
	movapd	 6 * SIZE + 1 * (xx) * SIZE(AO, %rax, 4), %xmm6

	PROLOGUE
	PROFCODE
	
	subq	$STACKSIZE, %rsp
	
	movq	%rbx,  0(%rsp)
	movq	%rbp,  8(%rsp)
	movq	%r12, 16(%rsp)
	movq	%r13, 24(%rsp)
	movq	%r14, 32(%rsp)
	movq	%r15, 40(%rsp)

	EMMS
	
	movq	72(%rsp), LDC	# LDC
#ifdef TRMMKERNEL
	movlpd	80(%rsp), %xmm12
#endif

	movq	%rsp, %rbx	# save old stack
	subq	$128 + LOCAL_BUFFER_SIZE, %rsp
	andq	$-4096, %rsp	# align stack

	movq	OLD_M, M
	movq	OLD_N, N

	pcmpeqb	%xmm7, %xmm7
	psllq	$63, %xmm7	# Generate mask
	pxor	%xmm10, %xmm10

	movlpd	 %xmm0, 0 + ALPHA_R
	movlpd	 %xmm0, 8 + ALPHA_R
	
	movlpd	 %xmm1, 8 + ALPHA_I
	xorpd	 %xmm7, %xmm1
	movlpd	 %xmm1, 0 + ALPHA_I

	movlpd	  %xmm10,  0 + POSINV
	movlpd	  %xmm7, 8 + POSINV

#ifdef TRMMKERNEL
	movlpd	%xmm12, OFFSET
	movlpd	%xmm12, KK
#ifndef LEFT
	negq	KK
#endif	
#endif

	subq	$-16 * SIZE, A

	salq	$ZBASE_SHIFT, LDC
	
	movq	N,  J
	sarq	$1, J		# j = (n >> 2)
	jle	.L100
	ALIGN_4

.L01:
#if defined(TRMMKERNEL) && defined(LEFT)
	movq	OFFSET, %rax
	movq	%rax, KK
#endif	

/* Copying to Sub Buffer */
	leaq	BUFFER, BO
	
	movq	K, %rax
	sarq	$2, %rax
	jle	.L03

	addq	%rax, %rax
	ALIGN_4
	
.L02:
	prefetch	 (RPREFETCHSIZE +  0)  * SIZE(B)

	movlpd	 0 * SIZE(B), %xmm8
	movlpd	 1 * SIZE(B), %xmm9
	movlpd	 2 * SIZE(B), %xmm10
	movlpd	 3 * SIZE(B), %xmm11

	prefetchw	 (WPREFETCHSIZE +  0)  * SIZE(BO)

	movlpd	 4 * SIZE(B), %xmm12
	movlpd	 5 * SIZE(B), %xmm13
	movlpd	 6 * SIZE(B), %xmm14
	movlpd	 7 * SIZE(B), %xmm15

	prefetchw	 (WPREFETCHSIZE +  8)  * SIZE(BO)

	movlpd	%xmm8,  0 * SIZE(BO)
	movlpd	%xmm8,  1 * SIZE(BO)
	movlpd	%xmm9,  2 * SIZE(BO)
	movlpd	%xmm9,  3 * SIZE(BO)

	prefetch	 (RPREFETCHSIZE +  8)  * SIZE(B)

	movlpd	%xmm10,  4 * SIZE(BO)
	movlpd	%xmm10,  5 * SIZE(BO)
	movlpd	%xmm11,  6 * SIZE(BO)
	movlpd	%xmm11,  7 * SIZE(BO)

	prefetchw	 (WPREFETCHSIZE + 16)  * SIZE(BO)

	movlpd	%xmm12,  8 * SIZE(BO)
	movlpd	%xmm12,  9 * SIZE(BO)
	movlpd	%xmm13, 10 * SIZE(BO)
	movlpd	%xmm13, 11 * SIZE(BO)

	prefetchw	 (WPREFETCHSIZE + 24)  * SIZE(BO)

	movlpd	%xmm14, 12 * SIZE(BO)
	movlpd	%xmm14, 13 * SIZE(BO)
	movlpd	%xmm15, 14 * SIZE(BO)
	movlpd	%xmm15, 15 * SIZE(BO)

	subq	$-16 * SIZE, BO
	addq	$  8 * SIZE, B
	decq	%rax
	jne	.L02
	ALIGN_4

.L03:
	movq	K, %rax
	andq	$3, %rax
	BRANCH
	jle	.L05
	ALIGN_4

.L04:
	movlpd	 0 * SIZE(B), %xmm8
	movlpd	 1 * SIZE(B), %xmm9
	movlpd	 2 * SIZE(B), %xmm10
	movlpd	 3 * SIZE(B), %xmm11

	movlpd	%xmm8,  0 * SIZE(BO)
	movlpd	%xmm8,  1 * SIZE(BO)
	movlpd	%xmm9,  2 * SIZE(BO)
	movlpd	%xmm9,  3 * SIZE(BO)
	movlpd	%xmm10,  4 * SIZE(BO)
	movlpd	%xmm10,  5 * SIZE(BO)
	movlpd	%xmm11,  6 * SIZE(BO)
	movlpd	%xmm11,  7 * SIZE(BO)

	addq	$ 4 * SIZE, B
	addq	$ 8 * SIZE, BO

	decq	%rax
	jne	.L04
	ALIGN_4
	
.L05:
	movq	C, CO1			# coffset1 = c
	leaq	(C, LDC, 1), CO2	# coffset2 = c + ldc
	movq	A, AO		# aoffset = a

	leaq	 (RPREFETCHSIZE +  0)  * SIZE(B), BB

	movq	M,  I
	sarq	$1, I		# i = (m >> 2)
	jle	.L30
	ALIGN_4

.L10:
	prefetch	  0  * SIZE(BB)
	prefetch	  8  * SIZE(BB)
	subq		 $-16 * SIZE, BB

#if !defined(TRMMKERNEL) || \
	(defined(TRMMKERNEL) &&  defined(LEFT) &&  defined(TRANSA)) || \
	(defined(TRMMKERNEL) && !defined(LEFT) && !defined(TRANSA))

	leaq	16 * SIZE + BUFFER, BO
#else
	leaq	16 * SIZE + BUFFER, BO
	movq	KK, %rax
	leaq	(, %rax, SIZE), %rax
	leaq	(AO, %rax, 4), AO
	leaq	(BO, %rax, 8), BO
#endif	

	movapd	-16 * SIZE(AO), %xmm0
	movapd	-16 * SIZE(BO), %xmm1
	pxor	%xmm8, %xmm8
	movapd	-14 * SIZE(AO), %xmm2
	movapd	-14 * SIZE(BO), %xmm3
	pxor	%xmm9, %xmm9
	movapd	-12 * SIZE(AO), %xmm4
	movapd	-12 * SIZE(BO), %xmm5
	pxor	%xmm10, %xmm10
	movapd	-10 * SIZE(AO), %xmm6
	movapd	 -8 * SIZE(BO), %xmm7
	pxor	%xmm11, %xmm11

	prefetchw      3 * SIZE(CO1)
	pxor	%xmm12, %xmm12
	prefetchw      3 * SIZE(CO2)
	pxor	%xmm13, %xmm13
	pxor	%xmm14, %xmm14
	pxor	%xmm15, %xmm15

#ifndef TRMMKERNEL
	movq	K, %rax
#elif (defined(LEFT) && !defined(TRANSA)) || (!defined(LEFT) && defined(TRANSA))
	movq	K, %rax
	subq	KK, %rax
	movq	%rax, KKK	
#else
	movq	KK, %rax
#ifdef LEFT
	addq	$2, %rax
#else
	addq	$2, %rax
#endif
	movq	%rax, KKK
#endif
	andq	$-8, %rax

	leaq	(, %rax, SIZE), %rax
	leaq	(AO, %rax, 4), AO
	leaq	(BO, %rax, 8), BO
	negq	%rax
	je,pn	.L15
	ALIGN_3

.L12:
	KERNEL(16 *  0)
	KERNEL(16 *  1)
	addq	$8 * SIZE, %rax
	je,pn	.L15
	KERNEL(16 *  0)
	KERNEL(16 *  1)
	addq	$8 * SIZE, %rax
	je,pn	.L15
	KERNEL(16 *  0)
	KERNEL(16 *  1)
	addq	$8 * SIZE, %rax
	je,pn	.L15
	KERNEL(16 *  0)
	KERNEL(16 *  1)
	addq	$8 * SIZE, %rax
	je,pn	.L15
	KERNEL(16 *  0)
	KERNEL(16 *  1)
	addq	$8 * SIZE, %rax
	je,pn	.L15
	KERNEL(16 *  0)
	KERNEL(16 *  1)
	addq	$8 * SIZE, %rax
	je,pn	.L15
	KERNEL(16 *  0)
	KERNEL(16 *  1)
	addq	$8 * SIZE, %rax
	je,pn	.L15
	KERNEL(16 *  0)
	KERNEL(16 *  1)
	addq	$8 * SIZE, %rax
	jl,pt	.L12
	ALIGN_3

.L15:
#ifndef TRMMKERNEL
	movq	K, %rax
#else
	movq	KKK, %rax
#endif
	testq	$4, %rax
	je .L16
	xorq	%rax, %rax
	ALIGN_3

	KERNEL(16 *  0)
	addq	$32 * SIZE, BO
	addq	$16 * SIZE, AO
	ALIGN_3

.L16:
	movapd	POSINV,  %xmm5
	movapd	ALPHA_R, %xmm6
	movapd	ALPHA_I, %xmm7

#ifndef TRMMKERNEL
	movq	K, %rax
#else
	movq	KKK, %rax
#endif
	andq	$3, %rax		# if (k & 1)
	je .L19

	leaq	(, %rax, SIZE), %rax
	leaq	(AO, %rax, 4), AO
	leaq	(BO, %rax, 8), BO
	negq	%rax
	ALIGN_3

.L17:
	mulpd	%xmm0, %xmm1
	addpd	%xmm1, %xmm8
	movapd	-14 * SIZE(BO, %rax, 8), %xmm1
	mulpd	%xmm0, %xmm1
	addpd	%xmm1, %xmm9
	movapd	-12 * SIZE(BO, %rax, 8), %xmm1
	mulpd	%xmm0, %xmm1
	mulpd	-10 * SIZE(BO, %rax, 8), %xmm0
	addpd	%xmm1, %xmm10
	movapd	-16 * SIZE(BO, %rax, 8), %xmm1
	addpd	%xmm0, %xmm11
	movapd	-12 * SIZE(AO, %rax, 4), %xmm0
	mulpd	%xmm2, %xmm1
	addpd	%xmm1, %xmm12
	movapd	-14 * SIZE(BO, %rax, 8), %xmm1
	mulpd	%xmm2, %xmm1
	addpd	%xmm1, %xmm13
	movapd	-12 * SIZE(BO, %rax, 8), %xmm1
	mulpd	%xmm2, %xmm1
	mulpd	-10 * SIZE(BO, %rax, 8), %xmm2
	addpd	%xmm1, %xmm14
	movapd	 -8 * SIZE(BO, %rax, 8), %xmm1
	addpd	%xmm2, %xmm15
	movapd	-10 * SIZE(AO, %rax, 4), %xmm2

	addq	$SIZE, %rax
	jl	.L17
	ALIGN_3

.L19:
#ifndef TRMMKERNEL
	movlpd	0 * SIZE(CO1), %xmm0
	movhpd	1 * SIZE(CO1), %xmm0
	movlpd	2 * SIZE(CO1), %xmm2
	movhpd	3 * SIZE(CO1), %xmm2

	movlpd	0 * SIZE(CO2), %xmm1
	movhpd	1 * SIZE(CO2), %xmm1
	movlpd	2 * SIZE(CO2), %xmm3
	movhpd	3 * SIZE(CO2), %xmm3
#endif

	shufpd	$1, %xmm9, %xmm9
	shufpd	$1, %xmm11, %xmm11
	shufpd	$1, %xmm13, %xmm13
	shufpd	$1, %xmm15, %xmm15

#if defined(NN) || defined(NT) || defined(TN) || defined(TT) || \
    defined(NR) || defined(NC) || defined(TR) || defined(TC)
	xorpd	%xmm5, %xmm9
	xorpd	%xmm5, %xmm11
	xorpd	%xmm5, %xmm13
	xorpd	%xmm5, %xmm15
#else
	xorpd	%xmm5, %xmm8
	xorpd	%xmm5, %xmm10
	xorpd	%xmm5, %xmm12
	xorpd	%xmm5, %xmm14
#endif

#if defined(NN) || defined(NT) || defined(TN) || defined(TT) || \
    defined(RR) || defined(RC) || defined(CR) || defined(CC)
	subpd	%xmm9, %xmm8
	subpd	%xmm11, %xmm10
	subpd	%xmm13, %xmm12
	subpd	%xmm15, %xmm14
#else
	addpd	%xmm9, %xmm8
	addpd	%xmm11, %xmm10
	addpd	%xmm13, %xmm12
	addpd	%xmm15, %xmm14
#endif

	pshufd	$0x4e, %xmm8, %xmm9
	pshufd	$0x4e, %xmm10, %xmm11
	pshufd	$0x4e, %xmm12, %xmm13
	pshufd	$0x4e, %xmm14, %xmm15
	
	mulpd	%xmm6, %xmm8
	mulpd	%xmm7, %xmm9
	mulpd	%xmm6, %xmm10
	mulpd	%xmm7, %xmm11

	mulpd	%xmm6, %xmm12
	mulpd	%xmm7, %xmm13
	mulpd	%xmm6, %xmm14
	mulpd	%xmm7, %xmm15

	addpd	%xmm9, %xmm8
	addpd	%xmm11, %xmm10
	addpd	%xmm13, %xmm12
	addpd	%xmm15, %xmm14

#ifndef TRMMKERNEL
	addpd	%xmm0,  %xmm8
	addpd	%xmm2, %xmm12
	addpd	%xmm1,  %xmm10
	addpd	%xmm3, %xmm14
#endif

	movlpd	%xmm8, 0 * SIZE(CO1)
	movhpd	%xmm8, 1 * SIZE(CO1)
	movlpd	%xmm12, 2 * SIZE(CO1)
	movhpd	%xmm12, 3 * SIZE(CO1)

	movlpd	%xmm10, 0 * SIZE(CO2)
	movhpd	%xmm10, 1 * SIZE(CO2)
	movlpd	%xmm14, 2 * SIZE(CO2)
	movhpd	%xmm14, 3 * SIZE(CO2)

#if (defined(TRMMKERNEL) &&  defined(LEFT) &&  defined(TRANSA)) || \
    (defined(TRMMKERNEL) && !defined(LEFT) && !defined(TRANSA))
	movq	K, %rax
	subq	KKK, %rax
	leaq	(,%rax, SIZE), %rax
	leaq	(AO, %rax, 4), AO
	leaq	(BO, %rax, 8), BO
#endif

#if defined(TRMMKERNEL) && defined(LEFT)
	addq	$2, KK
#endif

	addq	$4 * SIZE, CO1		# coffset += 4
	addq	$4 * SIZE, CO2		# coffset += 4
	decq	I			# i --
	jg	.L10
	ALIGN_4	

.L30:
	testq	$1, M
	jle	.L99

#if !defined(TRMMKERNEL) || \
	(defined(TRMMKERNEL) &&  defined(LEFT) &&  defined(TRANSA)) || \
	(defined(TRMMKERNEL) && !defined(LEFT) && !defined(TRANSA))

	leaq	16 * SIZE + BUFFER, BO
#else
	leaq	16 * SIZE + BUFFER, BO
	movq	KK, %rax
	leaq	(, %rax, SIZE), %rax
	leaq	(AO, %rax, 2), AO
	leaq	(BO, %rax, 8), BO
#endif	

	movapd	-16 * SIZE(AO), %xmm0
	pxor	%xmm8, %xmm8
	movapd	 -8 * SIZE(AO), %xmm2
	pxor	%xmm9, %xmm9
	movapd	-16 * SIZE(BO), %xmm1
	pxor	%xmm10, %xmm10
	movapd	 -8 * SIZE(BO), %xmm3
	pxor	%xmm11, %xmm11

#ifndef TRMMKERNEL
	movq	K, %rax
#elif (defined(LEFT) && !defined(TRANSA)) || (!defined(LEFT) && defined(TRANSA))
	movq	K, %rax
	subq	KK, %rax
	movq	%rax, KKK	
#else
	movq	KK, %rax
#ifdef LEFT
	addq	$1, %rax
#else
	addq	$2, %rax
#endif
	movq	%rax, KKK
#endif
	sarq	$3, %rax
	je	.L44
	ALIGN_4	

.L41:
	mulpd	%xmm0, %xmm1
	addpd	%xmm1, %xmm8
	movapd	-14 * SIZE(BO), %xmm1
	mulpd	%xmm0, %xmm1
	PREFETCH	(PREFETCHSIZE     +  0) * SIZE(AO)
	addpd	%xmm1, %xmm9
	movapd	-12 * SIZE(BO), %xmm1
	mulpd	%xmm0, %xmm1
	mulpd	-10 * SIZE(BO), %xmm0
	addpd	%xmm1, %xmm10
	movapd	  0 * SIZE(BO), %xmm1
	addpd	%xmm0, %xmm11
	movapd	-14 * SIZE(AO), %xmm0
	mulpd	%xmm0, %xmm3
	addpd	%xmm3, %xmm8
	movapd	 -6 * SIZE(BO), %xmm3
	mulpd	%xmm0, %xmm3
	addpd	%xmm3, %xmm9
	movapd	 -4 * SIZE(BO), %xmm3
	mulpd	%xmm0, %xmm3
	mulpd	 -2 * SIZE(BO), %xmm0
	addpd	%xmm3, %xmm10
	movapd	  8 * SIZE(BO), %xmm3
	addpd	%xmm0, %xmm11
	movapd	-12 * SIZE(AO), %xmm0
	mulpd	%xmm0, %xmm1
	addpd	%xmm1, %xmm8
	movapd	  2 * SIZE(BO), %xmm1
	mulpd	%xmm0, %xmm1
	PREFETCH	(PREFETCHSIZE     +  8) * SIZE(AO)
	addpd	%xmm1, %xmm9
	movapd	  4 * SIZE(BO), %xmm1
	mulpd	%xmm0, %xmm1
	mulpd	  6 * SIZE(BO), %xmm0
	addpd	%xmm1, %xmm10
	movapd	 16 * SIZE(BO), %xmm1
	addpd	%xmm0, %xmm11
	movapd	-10 * SIZE(AO), %xmm0
	mulpd	%xmm0, %xmm3
	addpd	%xmm3, %xmm8
	movapd	 10 * SIZE(BO), %xmm3
	mulpd	%xmm0, %xmm3
	addpd	%xmm3, %xmm9
	movapd	 12 * SIZE(BO), %xmm3
	mulpd	%xmm0, %xmm3
	mulpd	 14 * SIZE(BO), %xmm0
	addpd	%xmm3, %xmm10
	movapd	 24 * SIZE(BO), %xmm3
	addpd	%xmm0, %xmm11
	movapd	  0 * SIZE(AO), %xmm0
	mulpd	%xmm2, %xmm1
	addpd	%xmm1, %xmm8
	movapd	 18 * SIZE(BO), %xmm1
	mulpd	%xmm2, %xmm1
	addpd	%xmm1, %xmm9
	movapd	 20 * SIZE(BO), %xmm1
	mulpd	%xmm2, %xmm1
	mulpd	 22 * SIZE(BO), %xmm2
	addpd	%xmm1, %xmm10
	movapd	 32 * SIZE(BO), %xmm1
	addpd	%xmm2, %xmm11
	movapd	 -6 * SIZE(AO), %xmm2
	mulpd	%xmm2, %xmm3
	addpd	%xmm3, %xmm8
	movapd	 26 * SIZE(BO), %xmm3
	mulpd	%xmm2, %xmm3
	addpd	%xmm3, %xmm9
	movapd	 28 * SIZE(BO), %xmm3
	mulpd	%xmm2, %xmm3
	mulpd	 30 * SIZE(BO), %xmm2
	addpd	%xmm3, %xmm10
	movapd	 40 * SIZE(BO), %xmm3
	addpd	%xmm2, %xmm11
	movapd	 -4 * SIZE(AO), %xmm2
	mulpd	%xmm2, %xmm1
	addpd	%xmm1, %xmm8
	movapd	 34 * SIZE(BO), %xmm1
	mulpd	%xmm2, %xmm1
	addpd	%xmm1, %xmm9
	movapd	 36 * SIZE(BO), %xmm1
	mulpd	%xmm2, %xmm1
	mulpd	 38 * SIZE(BO), %xmm2
	addpd	%xmm1, %xmm10
	movapd	 48 * SIZE(BO), %xmm1
	addpd	%xmm2, %xmm11
	movapd	 -2 * SIZE(AO), %xmm2
	mulpd	%xmm2, %xmm3
	addpd	%xmm3, %xmm8
	movapd	 42 * SIZE(BO), %xmm3
	mulpd	%xmm2, %xmm3
	addpd	%xmm3, %xmm9
	movapd	 44 * SIZE(BO), %xmm3
	mulpd	%xmm2, %xmm3
	mulpd	 46 * SIZE(BO), %xmm2
	addpd	%xmm3, %xmm10
	movapd	 56 * SIZE(BO), %xmm3
	addpd	%xmm2, %xmm11
	movapd	  8 * SIZE(AO), %xmm2

	subq   $-16 * SIZE, AO
	addq   $64 * SIZE, BO
	decq   %rax
	jne    .L41
	ALIGN_4	

.L44:
#ifndef TRMMKERNEL
	movq	K, %rax
#else
	movq	KKK, %rax
#endif
	andq	$4, %rax
	BRANCH
	jle .L45

	mulpd	%xmm0, %xmm1
	addpd	%xmm1, %xmm8
	movapd	-14 * SIZE(BO), %xmm1
	mulpd	%xmm0, %xmm1
	addpd	%xmm1, %xmm9
	movapd	-12 * SIZE(BO), %xmm1
	mulpd	%xmm0, %xmm1
	mulpd	-10 * SIZE(BO), %xmm0
	addpd	%xmm1, %xmm10
	movapd	  0 * SIZE(BO), %xmm1
	addpd	%xmm0, %xmm11
	movapd	-14 * SIZE(AO), %xmm0
	mulpd	%xmm0, %xmm3
	addpd	%xmm3, %xmm8
	movapd	 -6 * SIZE(BO), %xmm3
	mulpd	%xmm0, %xmm3
	addpd	%xmm3, %xmm9
	movapd	 -4 * SIZE(BO), %xmm3
	mulpd	%xmm0, %xmm3
	mulpd	 -2 * SIZE(BO), %xmm0
	addpd	%xmm3, %xmm10
	movapd	  8 * SIZE(BO), %xmm3
	addpd	%xmm0, %xmm11
	movapd	-12 * SIZE(AO), %xmm0
	mulpd	%xmm0, %xmm1
	addpd	%xmm1, %xmm8
	movapd	  2 * SIZE(BO), %xmm1
	mulpd	%xmm0, %xmm1
	addpd	%xmm1, %xmm9
	movapd	  4 * SIZE(BO), %xmm1
	mulpd	%xmm0, %xmm1
	mulpd	  6 * SIZE(BO), %xmm0
	addpd	%xmm1, %xmm10
	movapd	 16 * SIZE(BO), %xmm1
	addpd	%xmm0, %xmm11
	movapd	-10 * SIZE(AO), %xmm0
	mulpd	%xmm0, %xmm3
	addpd	%xmm3, %xmm8
	movapd	 10 * SIZE(BO), %xmm3
	mulpd	%xmm0, %xmm3
	addpd	%xmm3, %xmm9
	movapd	 12 * SIZE(BO), %xmm3
	mulpd	%xmm0, %xmm3
	mulpd	 14 * SIZE(BO), %xmm0
	addpd	%xmm3, %xmm10
	movapd	 24 * SIZE(BO), %xmm3
	addpd	%xmm0, %xmm11
	movapd	 -8 * SIZE(AO), %xmm0

	addq   $ 8 * SIZE, AO
	addq   $32 * SIZE, BO
	ALIGN_4	

.L45:
#ifndef TRMMKERNEL
	movq	K, %rax
#else
	movq	KKK, %rax
#endif
	movapd	POSINV,  %xmm5
	movapd	ALPHA_R, %xmm6
	movapd	ALPHA_I, %xmm7
	andq	$3, %rax		# if (k & 1)
	BRANCH
	jle .L47
	ALIGN_4	

.L46:
	mulpd	%xmm0, %xmm1
	addpd	%xmm1, %xmm8
	movapd	-14 * SIZE(BO), %xmm1
	mulpd	%xmm0, %xmm1
	addpd	%xmm1, %xmm9
	movapd	-12 * SIZE(BO), %xmm1
	mulpd	%xmm0, %xmm1
	mulpd	-10 * SIZE(BO), %xmm0
	addpd	%xmm1, %xmm10
	movapd	 -8 * SIZE(BO), %xmm1
	addpd	%xmm0, %xmm11
	movapd	-14 * SIZE(AO), %xmm0

	addq	$2 * SIZE, AO
	addq	$8 * SIZE, BO

	decq	%rax
	jg	.L46
	ALIGN_4

.L47:
#ifndef TRMMKERNEL
	movlpd	0 * SIZE(CO1), %xmm0
	movhpd	1 * SIZE(CO1), %xmm0
	movlpd	0 * SIZE(CO2), %xmm1
	movhpd	1 * SIZE(CO2), %xmm1
#endif

	shufpd	$1, %xmm9, %xmm9
	shufpd	$1, %xmm11, %xmm11

#if defined(NN) || defined(NT) || defined(TN) || defined(TT) || \
    defined(NR) || defined(NC) || defined(TR) || defined(TC)
	xorpd	%xmm5, %xmm9
	xorpd	%xmm5, %xmm11
#else
	xorpd	%xmm5, %xmm8
	xorpd	%xmm5, %xmm10
#endif

#if defined(NN) || defined(NT) || defined(TN) || defined(TT) || \
    defined(RR) || defined(RC) || defined(CR) || defined(CC)
	subpd	%xmm9, %xmm8
	subpd	%xmm11, %xmm10
#else
	addpd	%xmm9, %xmm8
	addpd	%xmm11, %xmm10
#endif

	pshufd	$0x4e, %xmm8, %xmm9
	pshufd	$0x4e, %xmm10, %xmm11
	
	mulpd	%xmm6, %xmm8
	mulpd	%xmm7, %xmm9
	mulpd	%xmm6, %xmm10
	mulpd	%xmm7, %xmm11

	addpd	%xmm9, %xmm8
	addpd	%xmm11, %xmm10

#ifndef TRMMKERNEL
	addpd	%xmm0,  %xmm8
	addpd	%xmm1,  %xmm10
#endif

	movlpd	%xmm8, 0 * SIZE(CO1)
	movhpd	%xmm8, 1 * SIZE(CO1)
	movlpd	%xmm10, 0 * SIZE(CO2)
	movhpd	%xmm10, 1 * SIZE(CO2)

#if (defined(TRMMKERNEL) &&  defined(LEFT) &&  defined(TRANSA)) || \
    (defined(TRMMKERNEL) && !defined(LEFT) && !defined(TRANSA))
	movq	K, %rax
	subq	KKK, %rax
	leaq	(,%rax, SIZE), %rax
	leaq	(AO, %rax, 2), AO
	leaq	(BO, %rax, 8), BO
#endif

#if defined(TRMMKERNEL) && defined(LEFT)
	addq	$1, KK
#endif
	ALIGN_4
	
.L99:
#if defined(TRMMKERNEL) && !defined(LEFT)
	addl	$2, KK
#endif

	leaq	(C, LDC, 2), C		# c += 2 * ldc
	decq	J			# j --
	jg	.L01

.L100:
	testq	$1, N
	jle	.L999

.L101:
#if defined(TRMMKERNEL) && defined(LEFT)
	movq	OFFSET, %rax
	movq	%rax, KK
#endif	

/* Copying to Sub Buffer */
	leaq	BUFFER, BO

	movq	K, %rax
	sarq	$2, %rax
	jle	.L103
	ALIGN_4
	
.L102:
	movlpd	 0 * SIZE(B), %xmm8
	movlpd	 1 * SIZE(B), %xmm9
	movlpd	 2 * SIZE(B), %xmm10
	movlpd	 3 * SIZE(B), %xmm11
	movlpd	 4 * SIZE(B), %xmm12
	movlpd	 5 * SIZE(B), %xmm13
	movlpd	 6 * SIZE(B), %xmm14
	movlpd	 7 * SIZE(B), %xmm15

	movlpd	%xmm8,  0 * SIZE(BO)
	movlpd	%xmm8,  1 * SIZE(BO)
	movlpd	%xmm9,  2 * SIZE(BO)
	movlpd	%xmm9,  3 * SIZE(BO)
	movlpd	%xmm10,  4 * SIZE(BO)
	movlpd	%xmm10,  5 * SIZE(BO)
	movlpd	%xmm11,  6 * SIZE(BO)
	movlpd	%xmm11,  7 * SIZE(BO)
	movlpd	%xmm12,  8 * SIZE(BO)
	movlpd	%xmm12,  9 * SIZE(BO)
	movlpd	%xmm13, 10 * SIZE(BO)
	movlpd	%xmm13, 11 * SIZE(BO)
	movlpd	%xmm14, 12 * SIZE(BO)
	movlpd	%xmm14, 13 * SIZE(BO)
	movlpd	%xmm15, 14 * SIZE(BO)
	movlpd	%xmm15, 15 * SIZE(BO)

	subq	$-16 * SIZE, BO
	addq	$ 8 * SIZE, B
	decq	%rax
	jne	.L102
	ALIGN_4

.L103:
	movq	K, %rax
	andq	$3, %rax
	BRANCH
	jle	.L105
	ALIGN_4

.L104:
	movlpd	 0 * SIZE(B), %xmm8
	movlpd	 1 * SIZE(B), %xmm9

	movlpd	%xmm8,  0 * SIZE(BO)
	movlpd	%xmm8,  1 * SIZE(BO)
	movlpd	%xmm9,  2 * SIZE(BO)
	movlpd	%xmm9,  3 * SIZE(BO)

	addq	$4 * SIZE, BO
	addq	$2 * SIZE, B
	decq	%rax
	jne	.L104
	ALIGN_4
	
.L105:
	movq	C, CO1		# coffset1 = c
	movq	A, AO		# aoffset = a

	movq	M,  I
	sarq	$1, I		# i = (m >> 2)
	jle	.L130
	ALIGN_4

.L110:
#if !defined(TRMMKERNEL) || \
	(defined(TRMMKERNEL) &&  defined(LEFT) &&  defined(TRANSA)) || \
	(defined(TRMMKERNEL) && !defined(LEFT) && !defined(TRANSA))

	leaq	16 * SIZE + BUFFER, BO
#else
	leaq	16 * SIZE + BUFFER, BO
	movq	KK, %rax
	leaq	(, %rax, SIZE), %rax
	leaq	(AO, %rax, 4), AO
	leaq	(BO, %rax, 4), BO
#endif	

	movapd	-16 * SIZE(AO), %xmm0
	pxor	%xmm8, %xmm8
	movapd	-16 * SIZE(BO), %xmm1
	pxor	%xmm9, %xmm9
	movapd	 -8 * SIZE(AO), %xmm2
	pxor	%xmm12, %xmm12
	movapd	 -8 * SIZE(BO), %xmm3
	pxor	%xmm13, %xmm13
	prefetchw      3 * SIZE(CO1)

#ifndef TRMMKERNEL
	movq	K, %rax
#elif (defined(LEFT) && !defined(TRANSA)) || (!defined(LEFT) && defined(TRANSA))
	movq	K, %rax
	subq	KK, %rax
	movq	%rax, KKK	
#else
	movq	KK, %rax
#ifdef LEFT
	addq	$2, %rax
#else
	addq	$1, %rax
#endif
	movq	%rax, KKK
#endif
	sarq	$2, %rax
	je	.L112

.L111:
	mulpd	%xmm0, %xmm1
	PREFETCH	(PREFETCHSIZE     +  0) * SIZE(AO)
	mulpd	-14 * SIZE(BO), %xmm0
	addpd	%xmm1, %xmm8
	movapd	-16 * SIZE(BO), %xmm1
	addpd	%xmm0, %xmm9
	movapd	-14 * SIZE(AO), %xmm0
	mulpd	%xmm0, %xmm1
	mulpd	-14 * SIZE(BO), %xmm0
	addpd	%xmm1, %xmm12
	movapd	-12 * SIZE(BO), %xmm1
	addpd	%xmm0, %xmm13
	movapd	-12 * SIZE(AO), %xmm0
	mulpd	%xmm0, %xmm1
	mulpd	-10 * SIZE(BO), %xmm0
	addpd	%xmm1, %xmm8
	movapd	-12 * SIZE(BO), %xmm1
	addpd	%xmm0, %xmm9
	movapd	-10 * SIZE(AO), %xmm0
	mulpd	%xmm0, %xmm1
	mulpd	-10 * SIZE(BO), %xmm0
	addpd	%xmm1, %xmm12
	movapd	  0 * SIZE(BO), %xmm1
	addpd	%xmm0, %xmm13
	movapd	  0 * SIZE(AO), %xmm0
	mulpd	%xmm2, %xmm3
	PREFETCH	(PREFETCHSIZE     +  8) * SIZE(AO)
	mulpd	 -6 * SIZE(BO), %xmm2
	addpd	%xmm3, %xmm8
	movapd	 -8 * SIZE(BO), %xmm3
	addpd	%xmm2, %xmm9
	movapd	 -6 * SIZE(AO), %xmm2
	mulpd	%xmm2, %xmm3
	mulpd	 -6 * SIZE(BO), %xmm2
	addpd	%xmm3, %xmm12
	movapd	 -4 * SIZE(BO), %xmm3
	addpd	%xmm2, %xmm13
	movapd	 -4 * SIZE(AO), %xmm2
	mulpd	%xmm2, %xmm3
	mulpd	 -2 * SIZE(BO), %xmm2
	addpd	%xmm3, %xmm8
	movapd	 -4 * SIZE(BO), %xmm3
	addpd	%xmm2, %xmm9
	movapd	 -2 * SIZE(AO), %xmm2
	mulpd	%xmm2, %xmm3
	mulpd	 -2 * SIZE(BO), %xmm2
	addpd	%xmm3, %xmm12
	movapd	  8 * SIZE(BO), %xmm3
	addpd	%xmm2, %xmm13
	movapd	  8 * SIZE(AO), %xmm2

	subq   $-16 * SIZE, AO
	subq   $-16 * SIZE, BO
	decq   %rax
	jne    .L111
	ALIGN_4

.L112:
#ifndef TRMMKERNEL
	movq	K, %rax
#else
	movq	KKK, %rax
#endif
	movapd	POSINV,  %xmm5
	movapd	ALPHA_R, %xmm6
	movapd	ALPHA_I, %xmm7
	andq	$3, %rax		# if (k & 1)
	BRANCH
	jle .L114

.L113:
	mulpd	%xmm0, %xmm1
	mulpd	 -14 * SIZE(BO), %xmm0
	addpd	%xmm1, %xmm8
	movapd	 -16 * SIZE(BO), %xmm1
	addpd	%xmm0, %xmm9
	movapd	 -14 * SIZE(AO), %xmm0
	mulpd	%xmm0, %xmm1
	mulpd	 -14 * SIZE(BO), %xmm0
	addpd	%xmm1, %xmm12
	movapd	 -12 * SIZE(BO), %xmm1
	addpd	%xmm0, %xmm13
	movapd	 -12 * SIZE(AO), %xmm0

	addq	$4 * SIZE, AO		# aoffset  += 4
	addq	$4 * SIZE, BO		# boffset1 += 8
	decq	%rax
	jg	.L113
	ALIGN_4

.L114:
#ifndef TRMMKERNEL
	movlpd	0 * SIZE(CO1), %xmm0
	movhpd	1 * SIZE(CO1), %xmm0
	movlpd	2 * SIZE(CO1), %xmm2
	movhpd	3 * SIZE(CO1), %xmm2
#endif

	shufpd	$1, %xmm9, %xmm9
	shufpd	$1, %xmm13, %xmm13

#if defined(NN) || defined(NT) || defined(TN) || defined(TT) || \
    defined(NR) || defined(NC) || defined(TR) || defined(TC)
	xorpd	%xmm5, %xmm9
	xorpd	%xmm5, %xmm13
#else
	xorpd	%xmm5, %xmm8
	xorpd	%xmm5, %xmm12
#endif

#if defined(NN) || defined(NT) || defined(TN) || defined(TT) || \
    defined(RR) || defined(RC) || defined(CR) || defined(CC)
	subpd	%xmm9, %xmm8
	subpd	%xmm13, %xmm12
#else
	addpd	%xmm9, %xmm8
	addpd	%xmm13, %xmm12
#endif

	pshufd	$0x4e, %xmm8, %xmm9
	pshufd	$0x4e, %xmm12, %xmm13
	
	mulpd	%xmm6, %xmm8
	mulpd	%xmm7, %xmm9
	mulpd	%xmm6, %xmm12
	mulpd	%xmm7, %xmm13

	addpd	%xmm9, %xmm8
	addpd	%xmm13, %xmm12

#ifndef TRMMKERNEL
	addpd	%xmm0,  %xmm8
	addpd	%xmm2, %xmm12
#endif

	movlpd	%xmm8, 0 * SIZE(CO1)
	movhpd	%xmm8, 1 * SIZE(CO1)
	movlpd	%xmm12, 2 * SIZE(CO1)
	movhpd	%xmm12, 3 * SIZE(CO1)

#if (defined(TRMMKERNEL) &&  defined(LEFT) &&  defined(TRANSA)) || \
    (defined(TRMMKERNEL) && !defined(LEFT) && !defined(TRANSA))
	movq	K, %rax
	subq	KKK, %rax
	leaq	(,%rax, SIZE), %rax
	leaq	(AO, %rax, 4), AO
	leaq	(BO, %rax, 4), BO
#endif

#if defined(TRMMKERNEL) && defined(LEFT)
	addq	$2, KK
#endif

	addq	$4 * SIZE, CO1		# coffset += 4
	decq	I			# i --
	jg	.L110
	ALIGN_4	

.L130:
	testq	$1, M
	jle	.L999

#if !defined(TRMMKERNEL) || \
	(defined(TRMMKERNEL) &&  defined(LEFT) &&  defined(TRANSA)) || \
	(defined(TRMMKERNEL) && !defined(LEFT) && !defined(TRANSA))

	leaq	16 * SIZE + BUFFER, BO
#else
	leaq	16 * SIZE + BUFFER, BO
	movq	KK, %rax
	leaq	(, %rax, SIZE), %rax
	leaq	(AO, %rax, 2), AO
	leaq	(BO, %rax, 4), BO
#endif	

	movapd	-16 * SIZE(AO), %xmm0
	movapd	-16 * SIZE(BO), %xmm1
	movapd	 -8 * SIZE(AO), %xmm2
	movapd	 -8 * SIZE(BO), %xmm3

	pxor	%xmm8, %xmm8
	pxor	%xmm9, %xmm9
	pxor	%xmm10, %xmm10
	pxor	%xmm11, %xmm11

#ifndef TRMMKERNEL
	movq	K, %rax
#elif (defined(LEFT) && !defined(TRANSA)) || (!defined(LEFT) && defined(TRANSA))
	movq	K, %rax
	subq	KK, %rax
	movq	%rax, KKK	
#else
	movq	KK, %rax
#ifdef LEFT
	addq	$1, %rax
#else
	addq	$1, %rax
#endif
	movq	%rax, KKK
#endif
	sarq	$3, %rax
	je	.L144
	ALIGN_4

.L141:
	mulpd	%xmm0, %xmm1
	PREFETCH	(PREFETCHSIZE     +  0) * SIZE(AO)
	mulpd	-14 * SIZE(BO), %xmm0
	addpd	%xmm1, %xmm8
	movapd	-12 * SIZE(BO), %xmm1
	addpd	%xmm0, %xmm9
	movapd	-14 * SIZE(AO), %xmm0
	mulpd	%xmm0, %xmm1
	mulpd	-10 * SIZE(BO), %xmm0
	addpd	%xmm1, %xmm10
	movapd	  0 * SIZE(BO), %xmm1
	addpd	%xmm0, %xmm11
	movapd	-12 * SIZE(AO), %xmm0
	mulpd	%xmm0, %xmm3
	mulpd	 -6 * SIZE(BO), %xmm0
	addpd	%xmm3, %xmm8
	movapd	 -4 * SIZE(BO), %xmm3
	addpd	%xmm0, %xmm9
	movapd	-10 * SIZE(AO), %xmm0
	mulpd	%xmm0, %xmm3
	mulpd	 -2 * SIZE(BO), %xmm0
	addpd	%xmm3, %xmm10
	movapd	  8 * SIZE(BO), %xmm3
	addpd	%xmm0, %xmm11
	movapd	  0 * SIZE(AO), %xmm0
	mulpd	%xmm2, %xmm1
	PREFETCH	(PREFETCHSIZE     +  8) * SIZE(AO)
	mulpd	  2 * SIZE(BO), %xmm2
	addpd	%xmm1, %xmm8
	movapd	  4 * SIZE(BO), %xmm1
	addpd	%xmm2, %xmm9
	movapd	 -6 * SIZE(AO), %xmm2
	mulpd	%xmm2, %xmm1
	mulpd	  6 * SIZE(BO), %xmm2
	addpd	%xmm1, %xmm10
	movapd	 16 * SIZE(BO), %xmm1
	addpd	%xmm2, %xmm11
	movapd	 -4 * SIZE(AO), %xmm2
	mulpd	%xmm2, %xmm3
	mulpd	 10 * SIZE(BO), %xmm2
	addpd	%xmm3, %xmm8
	movapd	 12 * SIZE(BO), %xmm3
	addpd	%xmm2, %xmm9
	movapd	 -2 * SIZE(AO), %xmm2
	mulpd	%xmm2, %xmm3
	mulpd	 14 * SIZE(BO), %xmm2
	addpd	%xmm3, %xmm10
	movapd	 24 * SIZE(BO), %xmm3
	addpd	%xmm2, %xmm11
	movapd	  8 * SIZE(AO), %xmm2

	subq   $-16 * SIZE, AO
	subq   $-32 * SIZE, BO
	decq   %rax
	jne    .L141
	ALIGN_4


.L144:
#ifndef TRMMKERNEL
	movq	K, %rax
#else
	movq	KKK, %rax
#endif
	andq	$4, %rax		# if (k & 1)
	BRANCH
	jle .L145

	mulpd	%xmm0, %xmm1
	mulpd	-14 * SIZE(BO), %xmm0
	addpd	%xmm1, %xmm8
	movapd	-12 * SIZE(BO), %xmm1
	addpd	%xmm0, %xmm9
	movapd	-14 * SIZE(AO), %xmm0
	mulpd	%xmm0, %xmm1
	mulpd	-10 * SIZE(BO), %xmm0
	addpd	%xmm1, %xmm10
	movapd	  0 * SIZE(BO), %xmm1
	addpd	%xmm0, %xmm11
	movapd	-12 * SIZE(AO), %xmm0
	mulpd	%xmm0, %xmm3
	mulpd	 -6 * SIZE(BO), %xmm0
	addpd	%xmm3, %xmm8
	movapd	 -4 * SIZE(BO), %xmm3
	addpd	%xmm0, %xmm9
	movapd	-10 * SIZE(AO), %xmm0
	mulpd	%xmm0, %xmm3
	mulpd	 -2 * SIZE(BO), %xmm0
	addpd	%xmm3, %xmm10
	addpd	%xmm0, %xmm11
	movapd	 -8 * SIZE(AO), %xmm0

	addq   $8   * SIZE, AO
	subq   $-16 * SIZE, BO
	ALIGN_4

.L145:
	movapd	POSINV, %xmm5
	movapd	ALPHA_R, %xmm6
	movapd	ALPHA_I, %xmm7

#ifndef TRMMKERNEL
	movq	K, %rax
#else
	movq	KKK, %rax
#endif
	andq	$3, %rax		# if (k & 1)
	BRANCH
	jle .L148
	ALIGN_4

.L146:
	mulpd	%xmm0, %xmm1
	mulpd	-14 * SIZE(BO), %xmm0
	addpd	%xmm1, %xmm8
	movapd	-12 * SIZE(BO), %xmm1
	addpd	%xmm0, %xmm9
	movapd	-14 * SIZE(AO), %xmm0

	addq	$2 * SIZE, AO		# aoffset  += 4
	addq	$4 * SIZE, BO		# boffset1 += 8
	decq	%rax
	jg	.L146
	ALIGN_4

.L148:
	addpd	%xmm10, %xmm8
	addpd	%xmm11, %xmm9

#ifndef TRMMKERNEL
	movlpd	0 * SIZE(CO1), %xmm0
	movhpd	1 * SIZE(CO1), %xmm0
#endif

	shufpd	$1, %xmm9, %xmm9

#if defined(NN) || defined(NT) || defined(TN) || defined(TT) || \
    defined(NR) || defined(NC) || defined(TR) || defined(TC)
	xorpd	%xmm5, %xmm9
#else
	xorpd	%xmm5, %xmm8
#endif

#if defined(NN) || defined(NT) || defined(TN) || defined(TT) || \
    defined(RR) || defined(RC) || defined(CR) || defined(CC)
	subpd	%xmm9, %xmm8
#else
	addpd	%xmm9, %xmm8
#endif

	pshufd	$0x4e, %xmm8, %xmm9
	
	mulpd	%xmm6, %xmm8
	mulpd	%xmm7, %xmm9

	addpd	%xmm9, %xmm8

#ifndef TRMMKERNEL
	addpd	%xmm0,  %xmm8
#endif

	movlpd	%xmm8, 0 * SIZE(CO1)
	movhpd	%xmm8, 1 * SIZE(CO1)
	ALIGN_4
	
.L999:
	movq	%rbx, %rsp
	EMMS
	
	movq	  0(%rsp), %rbx
	movq	  8(%rsp), %rbp
	movq	 16(%rsp), %r12
	movq	 24(%rsp), %r13
	movq	 32(%rsp), %r14
	movq	 40(%rsp), %r15
	addq	$STACKSIZE, %rsp
	ret

	EPILOGUE
